#!/bin/bash

# Use single quotes to declare string

# =====================================================================================
# Lines to patch

Before=(
	'ObjRender_SetPosition(id[1],CenX-32,CenY-16,0)'
	'ObjSprite2D_SetSourceRect(id[1],336,321,394,339)'
	'ObjRender_SetPosition(fron2[1],MaxX+27+32,MinY+65+16,0)'
	'ObjSprite2D_SetSourceRect(fron2[1],258,19,290,37)'
	'ObjSprite2D_SetSourceRect(kef1,277,58,309,71)'
	'ObjRender_SetPosition(id[stc+1],gx+spin1*2.8,gy+spin1*1.8,0)'
	'ObjRender_SetPosition(id[stc+1],gx+spin1*2.7,gy+spin1*1.8,0)'
)

After=(
	'ObjRender_SetPosition(id[1],CenX-32+4,CenY-16,0)'
	'ObjSprite2D_SetSourceRect(id[1],336,321,402,339)'
	'ObjRender_SetPosition(fron2[1],MaxX+31+32,MinY+65+16,0)'
	'ObjSprite2D_SetSourceRect(fron2[1],258,19,298,37)'
	'ObjSprite2D_SetSourceRect(kef1,271,56,312,72)'
	'ObjRender_SetPosition(id[stc+1],gx+spin1*2.5,gy+spin1*1.8,0)'
	'ObjRender_SetPosition(id[stc+1],gx+spin1*2.6,gy+spin1*1.8,0)'
)



# =====================================================================================
# Operations

# Escape special symbols

for ((i=0; i < ${#Before[@]}; i++)); do
	Before[i]=${Before[i]//\[/\\\[};
	After[i]=${After[i]//\[/\\\[};
	Before[i]=${Before[i]//\*/\\\*};
	After[i]=${After[i]//\*/\\\*};
done;

# ========================================
# Patch files

cd "../script/Th_mpp";
iconv -f SHIFT-JIS -t UTF-8 ThMpp_System.dnh > ThMpp_System.bck;
eval sed -i -e s/\'${Before[0]}\'/\'${After[0]}\'/g ThMpp_System.bck;
eval sed -i -e s/\'${Before[1]}\'/\'${After[1]}\'/g ThMpp_System.bck;
iconv -f UTF-8 -t SHIFT-JIS ThMpp_System.bck > ThMpp_System.dnh;
rm ThMpp_System.bck;
cd "../../patch/";

cd "../script/Th_mpp/lib";
iconv -f SHIFT-JIS -t UTF-8 Eff_Front.dnh > Eff_Front.bck;
eval sed -i -e s/\'${Before[2]}\'/\'${After[2]}\'/g Eff_Front.bck;
eval sed -i -e s/\'${Before[3]}\'/\'${After[3]}\'/g Eff_Front.bck;
iconv -f UTF-8 -t SHIFT-JIS Eff_Front.bck > Eff_Front.dnh;
rm Eff_Front.bck;
cd "../../../patch/";

cd "../script/Th_mpp/lib"
iconv -f SHIFT-JIS -t UTF-8 Eff_Front2.dnh > Eff_Front2.bck;
eval sed -i -e s/\'${Before[4]}\'/\'${After[4]}\'/g Eff_Front2.bck;
iconv -f UTF-8 -t SHIFT-JIS Eff_Front2.bck > Eff_Front2.dnh;
rm Eff_Front2.bck;
cd "../../../patch/";

cd "../script/Th_mpp/scene"
iconv -f SHIFT-JIS -t UTF-8 Package_RankSelectScene.dnh > Package_RankSelectScene.bck;
eval sed -i -e s/\'${Before[5]}\'/\'${After[5]}\'/g Package_RankSelectScene.bck;
iconv -f UTF-8 -t SHIFT-JIS Package_RankSelectScene.bck > Package_RankSelectScene.dnh;
rm Package_RankSelectScene.bck;
cd "../../../patch/";

cd "../script/Th_mpp/scene"
iconv -f SHIFT-JIS -t UTF-8 Package_RankSelectSceneEx.dnh > Package_RankSelectSceneEx.bck;
eval sed -i -e s/\'${Before[6]}\'/\'${After[6]}\'/g Package_RankSelectSceneEx.bck;
iconv -f UTF-8 -t SHIFT-JIS Package_RankSelectSceneEx.bck > Package_RankSelectSceneEx.dnh;
rm Package_RankSelectSceneEx.bck;
cd "../../../patch/";

# ========================================
# Change images

cp "./Misc/enm5_text.png" "../script/Th_mpp/enm/stg6/stg6img";

cp "./Misc/ename.png" "../script/Th_mpp/img/front";
cp "./Misc/enameEX.png" "../script/Th_mpp/img/front";
cp "./Misc/front00.png" "../script/Th_mpp/img/front";
cp "./Misc/hidden.png" "../script/Th_mpp/img/title";
cp "./Misc/mn.png" "../script/Th_mpp/img/front";
cp "./Misc/skill_name01.png" "../script/Th_mpp/img/front";
cp "./Misc/sl00.png" "../script/Th_mpp/img/title";
cp "./Misc/stage_logo.png" "../script/Th_mpp/img/front";
